unit Frrul;
{based on RULERS By Bill Murto and Frrul by Olivier Dahan
   
   ***** Fixed:
   * actually IS accurate now (just needed a 'word' to 'single' fix)
   * added 'UnitOfMeasure' for swapping from inches to cm
   * added 'Position' for setting direction of marks
   * removed unnecessary default values in declarations (much more effecient
   * to initialise values only in the 'Create' code)
   *****
   
   by gdW from Australia...
   gdwood@hotmail.com}
   
   
{$D-,L-,S-}
   
interface
   
uses
{$IFDEF WIN32} Windows,{$ELSE} WinTypes, WinProcs, {$ENDIF}
   SysUtils, Messages, Classes, Graphics, Controls,
   Forms;
   
type
   THZPosition = (posBottom,posTop);{added by gdW}
   TVTPosition = (posRight,posLeft);{added by gdW}
   TUnitOfMeasure = (umCentimetres,umInches);{added by gdW}
   
type
   THFrRUL = class(TGraphicControl)
   private
{ Private declarations }
      fHZPosition: THZPosition; {added by gdW}
      fUnitOfMeasure: TUnitOfMeasure; {added by gdW}
      fHRulerAlign: TAlign;
      procedure SeTHFrRULAlign(Value: TAlign);
      procedure SetPosition(Value: THZPosition);{added by gdW}
      procedure SetUnitOfMeasure(Value: TUnitOfMeasure);{added by gdW}
   protected
{ Protected declarations }
      procedure Paint; override;
   public
{ Public declarations }
      constructor Create(AOwner: TComponent); override;
   published
{ Published declarations }
      property AlignHRuler: TAlign read fHRulerAlign write SeTHFrRULAlign;
      property Position: THZPosition read fHZPosition
      write SetPosition;{added by gdW}
      property UnitOfMeasure: TUnitOfMeasure read fUnitOfMeasure
      write SetUnitOfMeasure;{added by gdW}
      property Color;
      property Height;
      property Width;
      property Visible;
   end;
      
   type
   TVFrRUL = class(TGraphicControl)
   private
{ Private declarations }
      fVTPosition: TVTPosition;{added by gdW}
      fUnitOfMeasure: TUnitOfMeasure; {added by gdW}
      fVRulerAlign: TAlign;
      procedure SeTVFrRULAlign(Value: TAlign);
      procedure SetPosition(Value: TVTPosition);{added by gdW}
      procedure SetUnitOfMeasure(Value: TUnitOfMeasure);{added by gdW}
   protected
{ Protected declarations }
      procedure Paint; override;
   public
{ Public declarations }
      constructor Create(AOwner: TComponent); override;
   published
{ Published declarations }
      property AlignVRuler: TAlign read fVRulerAlign write SeTVFrRULAlign;
      property Position: TVTPosition read fVTPosition
      write SetPosition;{added by gdW}
      property UnitOfMeasure: TUnitOfMeasure read fUnitOfMeasure
      write SetUnitOfMeasure;{added by gdW}
      property Color;
      property Height;
      property Width;
      property Visible;
   end;
      
      procedure Register;
      
implementation
{$IFDEF WIN32}
{$R *.D32}
{$ELSE}
{$R *.D16}
{$ENDIF}

procedure Register;
begin
   RegisterComponents('Report', [THFrRUL, TVFrRUL]);
end;

procedure THFrRUL.SeTHFrRULAlign(Value: TAlign);
begin
   if Value in [alTop, alBottom, alNone] then
   begin
      fHRulerAlign := Value;
      Align := Value;
   end;
end;

constructor THFrRUL.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   AlignHRuler := alNone;
   Color := clYellow;
   Height := 33;
   Width := 200;
   fUnitOfMeasure := umCentimetres;
   fHZPosition := posTop;
end;

procedure THFrRUL.SetPosition(Value: THZPosition);{added by gdW}
begin
   if fHZPosition <> Value then
   begin
      fHZPosition := Value;
      Invalidate;
   end;
end;

procedure THFrRUL.SetUnitOfMeasure(Value: TUnitOfMeasure);{added by gdW}
begin
   if fUnitOfMeasure <> Value then
   begin
      fUnitOfMeasure := Value;
      Invalidate;
   end;
end;

procedure THFrRUL.Paint;
var ath,X: Single;
   N: Word;
begin
   if fUnitOfMeasure = umCentimetres then {added by gdW}
   begin
      ath := Screen.PixelsPerInch / 12.7; { 1 inch = 2.54 (* 5 ) centimeters }
      N := 0; X := 0;
      with Canvas do
      begin
         Brush.Color := Color;
         FillRect(ClientRect);
         with ClientRect do
            Rectangle(Left, Top, Right, Bottom);
         while X < Width do
         begin
            if fHZPosition = posBottom then
            begin
               MoveTo(Trunc(X), 1);
               LineTo(Trunc(X), 6*(1 +
               byte(N mod 5 = 0) +
               byte(N mod 10 = 0)));
            end
            else
            begin
               MoveTo(Trunc(X),Height);
               LineTo(Trunc(X), 9*(3 -
               byte(N mod 5 = 0)));
            end;
            if (N > 0) and (N mod 5 = 0) then
               TextOut(PenPos.X+2, 9, IntToStr(N div 5));
            N := N + 1;
            X := X + ath;
         end;
      end;
   end;
   if fUnitOfMeasure = umInches then {added by gdW}
   begin
      ath := Screen.PixelsPerInch div 12;
      N := 0; X := 0;
      with Canvas do
      begin
         Brush.Color := Color;
         FillRect(ClientRect);
         with ClientRect do
            Rectangle(Left, Top, Right, Bottom);
         while X < Width do
         begin
            if fHZPosition = posBottom then
            begin
               MoveTo(Trunc(X), 1);
               LineTo(Trunc(X), 6*(1 + byte(N mod 6 = 0) +
               byte(N mod 12 = 0)));
            end
            else
            begin
               MoveTo(Trunc(X),Height);
               LineTo(Trunc(X), 9*(3 -
               byte(N mod 6 = 0)));
            end;
            if (N > 0) and (N mod 12 = 0) then
               TextOut(PenPos.X+3, 9, IntToStr(N div 12));
            N := N + 1;
            X := X + ath;
         end;
      end;
   end;
end;
{*********************************************}
procedure TVFrRUL.SeTVFrRULAlign(Value: TAlign);
begin
   if Value in [alLeft, alRight, alNone] then
   begin
      fVRulerAlign := Value;
      Align := Value;
   end;
end;

constructor TVFrRUL.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   AlignVRuler := alNone;
   Color := clYellow;
   Height := 200;
   Width := 33;
   fUnitOfMeasure := umCentimetres;
   fVTPosition := posLeft;
end;

procedure TVFrRUL.SetPosition(Value: TVTPosition);{added by gdW}
begin
   if fVTPosition <> Value then
   begin
      fVTPosition := Value;
      Invalidate;
   end;
end;

procedure TVFrRUL.SetUnitOfMeasure(Value: TUnitOfMeasure);{added by gdW}
begin
   if fUnitOfMeasure <> Value then
   begin
      fUnitOfMeasure := Value;
      Invalidate;
   end;
end;

procedure TVFrRUL.Paint;
var ath,Y : Single;
   N: Word;
begin
   if fUnitOfMeasure = umCentimetres then {added by gdW}
   begin
      ath := Screen.PixelsPerInch / 12.7;
      N := 0; Y := 0;
      with Canvas do
      begin
         Brush.Color := Color;
         FillRect(ClientRect);
         with ClientRect do
            Rectangle(Left, Top, Right, Bottom);
         while Y < Height do
         begin
            if fVTPosition = posRight then
            begin
               MoveTo(1, Trunc(Y));
               LineTo(6*(1 +
               byte(N mod 5 = 0)),Trunc(Y));
            end
            else
            begin
               MoveTo(Width,Trunc(Y));
               LineTo(9*(3 -
               byte(N mod 5 = 0)),Trunc(Y));
            end;
            if (N > 0) and (N mod 5 = 0) then
               TextOut(12, PenPos.Y-16, IntToStr(N div 5));
            N := N + 1;
            Y := Y + ath;
         end;
      end;
   end;

   if fUnitOfMeasure = umInches then {added by gdW}
   begin
      ath := Screen.PixelsPerInch div 12;
      N := 0; Y := 0;
      with Canvas do
      begin
         Brush.Color := Color;
         FillRect(ClientRect);
         with ClientRect do
            Rectangle(Left, Top, Right, Bottom);
         while Y < Height do
         begin
            if fVTPosition = posRight then
            begin
               MoveTo(1, Trunc(Y));
               LineTo(6*(1 + byte(N mod 6 = 0) +
               byte(N mod 12 = 0)),Trunc(Y));
            end
            else
            begin
               MoveTo(Width,Trunc(Y));
               LineTo(9*(3 -
               byte(N mod 6 = 0)),Trunc(Y));
            end;
            if (N > 0) and (N mod 12 = 0) then
               TextOut(12, PenPos.Y-16, IntToStr(N div 12));
            N := N + 1;
            Y := Y + ath;
         end;
      end;
   end;

end;

end.
